#include "config.h"
#include "pt_cornell_1_2_1.h"
#include <math.h>
#include "tft_master.h"
#include "tft_gfx.h"
#include <stdlib.h>
#include <plib.h>
#include <xc.h> 




volatile int V, v, vs, vs1;
static int Ph, Ps;
static float V1;
static int is=0, i=0, j=0, js=0;
static float x;
char buffer[60];


static struct pt pt_lcd, pt_angle;


static PT_THREAD (protothread_lcd(struct pt *pt)){
    PT_BEGIN(pt);
    while(1){
        /////////stretch sensor code/////////////////////////////////////////////////////
        //For my breathing rate y coordinate is between 50 and 100
        //Set channel of ADC so AN9 is sampled
        SetChanADC10( ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN9 ); 
        AcquireADC10();
        while(!AD1CON1bits.DONE){};
        //Set value from ADC to V
        V = ReadADC10(0);
        //V1 is the actual volatage from the stretch sensor
        V1= (float)V * 3.3 / 1023.0;
        //draw the waveform accross the TFT one point at a time
        if (j<320){
            tft_drawLine(js, vs1, j, V1*50, ILI9340_GREEN);
            vs1=V1*50;
            js=j;
            j=i+2;
        }
        //once waveform reaches end of TFT clear the screen and start over
        else{j=0; js=0; tft_fillScreen(ILI9340_BLACK);}
        
        ////////ECG code//////////////////////////////////////////////////////////////////
        //For my heart rate the y coordinate is between 75 and 235
        //Set channel of ADC so AN11 is sampled
        SetChanADC10( ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN11 );
        AcquireADC10();
        while(!AD1CON1bits.DONE){};
        V = ReadADC10(0);
        //scale V so it is in a form that could be used to plot waveform
        v= (V>>2)+20;
        //draw the waveform accross the TFT one point at a time
        if (i<320){
            tft_drawLine(is, vs, i, v, ILI9340_RED);
            vs=v;
            is=i;
            i=i+2;
        }
        //once waveform reaches end of TFT clear the screen and start over
        else{i=0; is=0; tft_fillScreen(ILI9340_BLACK);}
        
    PT_YIELD_TIME_msec(50);
    }
    PT_END(pt);
}


static PT_THREAD (protothread_angle(struct pt *pt)){
    //static int speed= 1775; //reverse
    //static int speed= 1881; //forward
    static int speed=1876;
    PT_BEGIN(pt);
    while(1){
      ////////stretch sensor code/////////////////////////////////////////////////////
      if (V1*50 > 100){
            Ps= 2800;
      }
      if (V1*50 < 50){
            Ps= 875;
      }
      else{
      Ps= 4*(V1*50)+700;}
      SetPulseOC3(0, Ps);
      
      ////////ECG code//////////////////////////////////////////////////////////////////  
      if (v>210){
          Ph= 2800;
      }
      if (v<130){
          Ph= 875;
      }
      else{
      Ph= (4/7)*v+(2380/3);}
      SetPulseOC2(0, Ph);
      PT_YIELD_TIME_msec(50);
     
     ////////paper roll code/////////////////////////////////////////////////////////////   
     SetPulseOC1(0, speed);  //1250 is about 90 degrees  800ns  //1812 little too slow 1750 is 1.4
    }  
    PT_END(pt);
}


int main(void){ 
    // === config threads ==========
    // turns OFF UART support and debugger pin, unless defines are set
    PT_setup();


    // === setup system wide interrupts  ========
    INTEnableSystemMultiVectoredInt();


    // init the display
    tft_init_hw();
    tft_begin();
    tft_fillScreen(ILI9340_BLACK);
    //240x320 vertical display
    tft_setRotation(1); // Use tft_setRotation(1) for 320x240


    // === now the threads ===================================
    // init the threads
    PT_INIT (&pt_lcd);
    PT_INIT(&pt_angle);


    // ===========the ADC setup====================================
    // configure and enable the ADC
    CloseADC10();	// ensure the ADC is off before setting the configuration
    // define setup parameters for OpenADC10
    // Turn module on | ouput in integer | trigger mode auto | enable autosample
    #define PARAM1  ADC_FORMAT_INTG16 | ADC_CLK_AUTO | ADC_AUTO_SAMPLING_OFF //
    // define setup parameters for OpenADC10
    // ADC ref external  | disable offset test | disable scan mode | do 1 sample | use single buf | alternate mode off
    #define PARAM2  ADC_VREF_AVDD_AVSS | ADC_OFFSET_CAL_DISABLE | ADC_SCAN_OFF | ADC_SAMPLES_PER_INT_1 | ADC_ALT_BUF_OFF | ADC_ALT_INPUT_OFF
    // Define setup parameters for OpenADC10
    // use peripherial bus clock | set sample time | set ADC clock divider
    #define PARAM3 ADC_CONV_CLK_PB | ADC_SAMPLE_TIME_5 | ADC_CONV_CLK_Tcy2 //ADC_SAMPLE_TIME_15| ADC_CONV_CLK_Tcy2
    // define setup parameters for OpenADC10
    // set AN11 and  as analog inputs
    #define PARAM4	ENABLE_AN11_ANA // pin 24
    // define setup parameters for OpenADC10
    // do not assign channels to scan
    #define PARAM5	SKIP_SCAN_ALL
    // use ground as neg ref for A | use AN11 for input A     
    // configure to sample AN11 
    SetChanADC10( ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN11 ); // configure to sample AN11
    OpenADC10( PARAM1, PARAM2, PARAM3, PARAM4, PARAM5 ); // configure ADC using the parameters defined above
    EnableADC10(); // Enable the ADC
   
  // === Config timer and output compares to make pulses ========
  // set up timer2 to generate the wave period
  OpenTimer2(T2_ON | T2_SOURCE_INT | T2_PS_1_32, 0x61A8); //20ms period


  // set up output compares
  OpenOC2(OC_ON | OC_TIMER2_SRC | OC_CONTINUE_PULSE ,1250,0); //
  OpenOC3(OC_ON | OC_TIMER2_SRC | OC_CONTINUE_PULSE ,1250,0); //
  OpenOC1(OC_ON | OC_TIMER2_SRC | OC_CONTINUE_PULSE ,1250,0); //
 
  PPSOutput(2, RPB5, OC2); //pin14 --> servo for heart
  PPSOutput(4, RPB9, OC3); //pin 18 --> servo for stretch sensor
  PPSOutput(1, RPB7, OC1); //pin 16--> servo for paper roll
 
  
    // schedule the threads
    while(1) {
        PT_SCHEDULE(protothread_lcd(&pt_lcd));
        PT_SCHEDULE (protothread_angle(&pt_angle));
    }
}
